function ICoor.LoadInstructions()
	local stgs = ICoor.Globals.Instructions;

	ICoor.Instructions:SetPoint(stgs.AnchorPoint, stgs.RelativeTo, stgs.RelativePoint, stgs.Location[1], stgs.Location[2]);
	ICoor.Instructions:SetSize(stgs.Size[1], stgs.Size[2]);

	ICoor.Instructions.Bar = CreateFrame("statusbar", "ICoor_Instructions_Bar", ICoor.Instructions, nil);
	ICoor.Instructions.Bar:SetMinMaxValues(0, 1);
	ICoor.Instructions.Bar:SetPoint("CENTER", ICoor.Instructions, "CENTER", 0, 0);
	ICoor.Instructions.Bar:SetSize(stgs.Size[1] - 2, stgs.Size[2] - 2);
	ICoor.Instructions.Bar:SetStatusBarTexture(ICoor.Globals.Textures.Gradient);
	local c = stgs.BarColor;
	ICoor.Instructions.Bar:SetStatusBarColor(c[1], c[2], c[3], c[4]);

	ICoor.Instructions.texture = ICoor.Instructions:CreateTexture(nil, "LOW");
	ICoor.Instructions.texture:SetTexture(ICoor.Globals.Textures.Flat);
	local c = stgs.Color;
	ICoor.Instructions.texture:SetVertexColor(c[1], c[2], c[3], c[4]);
	ICoor.Instructions.texture:SetAllPoints(ICoor.Instructions);

	ICoor.Instructions.Text = ICoor.Instructions.Bar:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	ICoor.Instructions.Text:SetFont(ICoor.Globals.Textures.Text, stgs.FontSize);
	local c = stgs.FontColor;
	ICoor.Instructions.Text:SetTextColor(c[1], c[2], c[3], c[4]);

	ICoor.Instructions.Text:SetPoint("LEFT", "ICoor_Instructions", "LEFT", 0, 0);
	ICoor.Instructions.Text:SetSize(stgs.Size[1] / 2, stgs.Size[2]);
	ICoor.Instructions.Text:SetJustifyH("CENTER");
	ICoor.Instructions.Text:SetWordWrap(true);
	ICoor.Instructions.Text:SetText("Not in a que.");

	ICoor.Instructions.Spell = ICoor.Instructions.Bar:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	ICoor.Instructions.Spell.Name = "No Spell";
	ICoor.Instructions.Spell:SetFont(ICoor.Globals.Textures.Text, stgs.FontSize);
	local c = stgs.FontColor;
	ICoor.Instructions.Spell:SetTextColor(c[1], c[2], c[3], c[4]);

	ICoor.Instructions.Spell:SetPoint("RIGHT", "ICoor_Instructions", "RIGHT", 0, 0);
	ICoor.Instructions.Spell:SetSize(stgs.Size[1] / 2, stgs.Size[2]);
	ICoor.Instructions.Spell:SetJustifyH("CENTER");
	ICoor.Instructions.Spell:SetWordWrap(true);
	ICoor.Instructions.Spell:SetText("No Spell");
end

function ICoor.Instructions:LoadName(name)
	self.Spell.Name = name;
	self.Spell:SetText(self.Spell.Name);
end

function ICoor.Instructions:Update()
	local pos = -1;
	for i = 1, 5 do
		if ICoor.Table[i] == GetUnitName("player", false) then
			pos = i;
			i = 6;
		end
	end
	if pos == 1 then
		self.Text:SetText("Your up next!");
	elseif pos == -1 then
		self.Text:SetText("Not in a que.");
	else
		self.Text:SetText(pos - 1 .." before you.");
	end
end

local function CreateDropDown()
	local info = UIDropDownMenu_CreateInfo();
	info.isTitle = 1;
	info.text = "Config";
	info.fontObject = GameFontNormalLeft;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	
	info = UIDropDownMenu_CreateInfo();
	info.notCheckable = nil;
	info.text = "Locked";
	info.checked = ICoor_Saves.Locked;
	info.func = function(self) ICoor_Saves.Locked = not ICoor_Saves.Locked end
	UIDropDownMenu_AddButton(info);

	info = UIDropDownMenu_CreateInfo();
	info.notCheckable = nil;
	info.text = "Show Queue";
	info.checked = ICoor_Saves.Queue;
	info.func = function(self) 
		ICoor_Saves.Queue = not ICoor_Saves.Queue;
		ICoor:ToggleAddon();
	end
	UIDropDownMenu_AddButton(info);

	info = UIDropDownMenu_CreateInfo();
	info.notCheckable = nil;
	info.text = "Play Warning";
	info.checked = ICoor_Saves.Playsound;
	info.func = function(self) ICoor_Saves.Playsound = not ICoor_Saves.Playsound end
	UIDropDownMenu_AddButton(info);
end

local dropDown = CreateFrame("Frame", "ICoor_Options_DropDown", UIParent, "UIDropDownMenuTemplate");
UIDropDownMenu_Initialize(dropDown, nil, "MENU");
dropDown.initialize = CreateDropDown;
local function MouseDown(self, button)
	if button == "RightButton" then
		ToggleDropDownMenu(1, nil, dropDown, "cursor", 3, -3);
	elseif button == "LeftButton" then
		if ICoor_Saves.Locked == false then
			self:StartMoving();
			self.isMoving = true;
		end
	end
end

local function MouseUp(self, button)
	if self.isMoving then
		self:StopMovingOrSizing();
		self.isMoving = false;
		ICoor_Saves.Position.AnchorPoint, ICoor_Saves.Position.RelativeTo, ICoor_Saves.Position.RelativePoint, ICoor_Saves.Position.Location[1], ICoor_Saves.Position.Location[2] = self:GetPoint();
	end
end

local function OnUpdate(self)
	self.Bar:SetValue(((GetTime() * 1000) - self.startTime) / (self.endTime - self.startTime));
	if GetTime() >= self.endTime then
		self:SetScript("OnUpdate", nil);
		self.Bar:SetValue(1);
	end
end

local function OnEvent(self, event, unitID, spell, rank, lineID, spellID)
	if event == "UNIT_SPELLCAST_START" then
		if spell == self.Spell.Name then
			local _, _, _, _, startTime, endTime, _, _, _ = UnitCastingInfo(unitID);
			self.startTime = startTime;
			self.endTime = endTime;
			self:SetScript("OnUpdate", OnUpdate);
			if ICoor.Table[1] == GetUnitName("player", false) then
				PlaySoundFile(ICoor.Globals.SoundFile, "SFX");
			end
		end
	elseif event == "UNIT_SPELLCAST_INTERRUPTED" then
		if spell == self.Spell.Name then
			self.Bar:SetStatusBarColor(0, 1, 0, 1);
		end
	elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
		if spell == self.Spell.Name then
			self.Bar:SetStatusBarColor(1, 0, 0, 1);
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		self:EnableMouse(true);
		self:RegisterForDrag("LeftButtonDown", "RightButtonDown");
		self:SetMovable(true);
		self:SetScript("OnMouseDown", MouseDown);
		self:SetScript("OnMouseUp", MouseUp);
	end
end

ICoor.Instructions:RegisterEvent("UNIT_SPELLCAST_START");
ICoor.Instructions:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED");
ICoor.Instructions:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
ICoor.Instructions:RegisterEvent("PLAYER_ENTERING_WORLD");
ICoor.Instructions:SetScript("OnEvent", OnEvent);